#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "upu2sampler4xi.py">
#<abstract4xi abstract = "UPU 2D sampler management"/>
#<refer4xi reference = "sampler4xi.py"/>
#<verify4xi verification = "10" target = "upu2sampler4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'UPU2Sampler4Xi',                      # ACK 5.51  p106 
            
            'create2sampler4upu',                  # ACK 5.51  p106  

            'get2samplerinfo4upu',                 # ACK 5.51  p108
 
            'release2sampler4upu',                 # ACK 5.51  p107                                         
            'retain2sampler4upu',                  # ACK 5.51  p107
 
            'set2sampler4upu',                     # ACK
            'set2samplercallback4upu',             # ACK 
                              
            'trace2sampler4upu'                    # ACK 
          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi

# -------------------------------------------------------------------------------------------------
# Buffer                           
# -------------------------------------------------------------------------------------------------
from upu2buffer4xi import get2bufferinfo4upu

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from upu2commandqueue4xi import UPU2CommandQueue4Xi
from upu2commandqueue4xi import create2commandqueue4upu 
from upu2commandqueue4xi import flush2commandqueue4upu
from upu2commandqueue4xi import finish2commandqueue4upu
from upu2commandqueue4xi import get2commandqueueinfo4upu
from upu2commandqueue4xi import release2commandqueue4upu
from upu2commandqueue4xi import retain2commandqueue4upu
from upu2commandqueue4xi import set2commandqueue4upu
from upu2commandqueue4xi import trace2commandqueue4upu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from upu2context4xi import UPU2Context4Xi 
from upu2context4xi import create2context4upu
from upu2context4xi import get2context4upu
from upu2context4xi import release2context4upu
from upu2context4xi import retain2context4upu
from upu2context4xi import set2context4upu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from upu2device4xi import UPU4Xi
from upu2device4xi import init2upu4xi 
from upu2device4xi import set2upu4xi
from upu2device4xi import get2upu4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from upu2event4xi import UPU2Event4Xi
from upu2event4xi import create2event4upu
from upu2event4xi import get2eventinfo4upu
from upu2event4xi import release2event4upu
from upu2event4xi import retain2event4upu
from upu2event4xi import set2eventcallback4upu 
from upu2event4xi import set2event4upu
from upu2event4xi import trace2event4upu
from upu2event4xi import wait2event4upu


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global upu2sampler4xi                                                   # Sampler FOR UPU

global upu2trace4xi                                                     # TRACE

           
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2sampler4upu" usage = "
#
#   print('=' *33)          
#   print('(Step 15A/25) OF UPU2SAMPLER4XI5TEST - TRYING TO TRACE UPU: ', time4xi())      
#   print('=' *33)      
#   trace2upu = None
#   try:
#       trace2upu = trace2sampler4upu() 
#       print('(Step 15B/25) OF UPU2SAMPLER4XI5TEST - TRACE2UPU: ', trace2upu)  
#       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4upu-failed {}; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4upu', 'METHOD': 'trace2sampler4upu'} 
#        except:
#       print('(Step 15Z1/25) OF UPU2SAMPLER4XI5TEST *** FAILED TO TRACE UPU: ', trace2upu) 
#      
#">
# -------------------------------------------------------------------------------------------------   
def trace2sampler4upu(task4trace2upu=None):  

    '''
    creates callback to upu2sampler4xi
    '''
    
    global upu2trace4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2sampler4upu" 
    method2print = "trace2sampler4upu"

    message2print = "{(Step 1A/33) started" + "; trace2sampler4upu-started: " + str(trace2sampler4upu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # <function trace2sampler4upu at 0x00000000038CF5C8> 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2upu-to-trace2sampler4upu: " + str(task4trace2upu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # None

    code2ack  = ' '
    code2nack = ' '    
    
    upu2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2upu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY UPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2upu = {}                                                                                            
            
        task4trace2upu['CLASS']   = "trace2sampler4upu"                                                               # UPUIZE ZPU TRACE!
        task4trace2upu['METHOD']  = "trace2sampler4upu" 
        task4trace2upu['MESSAGE'] = "{(Step 2Z0/33) failed" + "; trace2sampler4upu-failed " + str(upu2trace4xi)  + "; time: " + time4xi() + "}"               
  
        
        message2print = "{(Step 2A/33) set" + "; task4trace2upu-set-by-trace2sampler4upu to: " + str(task4trace2upu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4upu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4upu', 'METHOD': 'trace2sampler4upu'}; time: 22:37:25 11/07/11 Pacific Standard Time}

        
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # PARAMETER GIVEN BY UPUIZED CALLBACK !
    # -----------------------------------------------------------------------------------------          
    message2print = "{(Step 3A/33) try" + "; task4trace2upu-try-by-trace2sampler4upu: " + str(task4trace2upu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
    # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4upu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4upu', 'METHOD': 'trace2sampler4upu'}; time: 22:37:25 11/07/11 Pacific Standard Time}
    

    try:
        upu2trace4xi ['CLASS']  = task4trace2upu['CLASS']                                                      # UPUIZE UPU TRACE!
        upu2trace4xi ['METHOD']  = task4trace2upu['METHOD']
        upu2trace4xi ['MESSAGE'] = task4trace2upu['MESSAGE']
        
        message2print = "{(Step 3B/33) set" + "; upu2trace4xi-set-by-trace2sampler4upu to: " + str(upu2trace4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4upu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4upu', 'METHOD': 'trace2sampler4upu'}; time: 22:37:25 11/07/11 Pacific Standard Time}

        

        code2ack = code2ack + '3B-'         
    except:
        message2print = "{(Step 3Z1/33) failed" + "; upu-trace-failed-by-trace2sampler4upu: " + str(task4trace2upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z1-' 
        
    try:
        # =================================
        # SIMULATE UPU TRACE
        # =================================
        class2print   = task4trace2upu['CLASS']                                                                # UPUIZE UPU TRACE!
        method2print  = task4trace2upu['METHOD']
        
        message2print = task4trace2upu['MESSAGE']
        print4xi(class2print, method2print, message2print)                                                     # UPUIZED TRACE FOR OPENCL CALLBACK!
        # { trace2sampler4upu : trace2sampler4upu ; (Step 2Z0/33) failed; trace2sampler4upu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time} 
        
        
        code2ack = code2ack + '3C-'         
    except:
        class2print = "trace2sampler4upu"                                                                        # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2sampler4upu"   
        message2print = "{(Step 3Z2/33) failed" + "; simulation-of-upu-trace-failed-by-trace2sampler4upu: " + str(task4trace2upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z2-' 
        
    try:
        # =================================
        # NORMAL TRACE
        # =================================                     
        class2print = "trace2sampler4upu"                                                                        # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2sampler4upu"                
        message2print = "{(Step 3D/33) performed" + "; upu-trace-performed-by-trace2sampler4upu: " + str(task4trace2upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4upu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4upu', 'METHOD': 'trace2sampler4upu'}; time: 22:37:25 11/07/11 Pacific Standard Time}
 
        

        code2ack = code2ack + '3D-' 
    except:
        message2print = "{(Step 3Z3/33) failed" + "; upu-trace-failed-by-trace2sampler4upu: " + str(task4trace2upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z3-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; upu2trace4xi-returning-by-trace2sampler4upu: " + str(upu2trace4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4upu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time}', 
    #  'CLASS': 'trace2sampler4upu', 
    #  'METHOD': 'trace2sampler4upu'}; time: 22:37:25 11/07/11 Pacific Standard Time}

    return upu2trace4xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2samplercallback4upu" usage = "
#
#   print('(Step 14A/700) OF UPU2SAMPLER4XI5TEST - TRYING TO SET SAMPLER CALLBACK OF UPU ', time4xi())  
#   try:                               
#       response4setcallback2sampler = set2samplercallback4upu()                                                                                                 
#       print('(Step 14B/700) OF UPU2SAMPLER4XI5TEST - SET SAMPLER CALLBACK OF UPU TO: ', response4setcallback2sampler)   
#       # <function trace2sampler4upu at 0x00000000039676C8>
#   except:
#       print('(Step 14Z1/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO SET SAMPLER CALLBACK OF UPU ', time4xi())  
# 
#">
# ------------------------------------------------------------------------------------------------- 
 
def set2samplercallback4upu(task4set2samplercallback=None):

    '''
    registers callback function to upu2sampler4xi
    '''
    global upu2sampler4xi
    
    class2print = "set2samplercallback4upu" 
    method2print = "set2samplercallback4upu"
    
    message2print = "{(Step 1A/70) started" + "; set2samplercallback4upu-started: " + str(set2samplercallback4upu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function set2samplercallback4upu at 0x00000000038CF648> 
    
    try:
    
        upu2sampler4xi ['CALLBACK'] = trace2sampler4upu
        
        
        message2print = "{(Step 1C/70) returning" + "; callback-of-upu2sampler4xi-returning-by-set2samplercallback4upu: " + str(upu2sampler4xi ['CALLBACK']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print) 
        # <function trace2sampler4upu at 0x00000000038CF5C8>
        
        return upu2sampler4xi ['CALLBACK']      
        
    except:
        message2print = "{(Step 1Z1/70) failed" + "; callback2sampler-failed-by-set2samplercallback4upu: " + str(callback2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         

        message2print = "{(Step 1Z2/70) returning" + "; trace2sampler4upu-returning-by-set2samplercallback4upu: " + str(trace2sampler4upu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)      
            
        return trace2sampler4upu
            
#</function4xi> 




# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2sampler4upu" usage = "
#   #1     
#   print('(Step 2A/700) OF UPU2SAMPLER4XI5TEST - TRYING TO CREATE SAMPLER4UPU ', time4xi())      
#   try:
#       response4create2sampler = create2sampler4upu()                                                                  
#       keys2response = response4create2sampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2sampler[key2response])
#           # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-12B-14B-15B-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-32B-33B-34B-
#           # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
#           # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, ...
#           # CODE2ERROR  :  0
#           # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK':  ...
#           # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
#           # COUNT2REFERENCE  :  1
#           # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4upu-failed ; time: 04:27:49 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4upu', 'METHOD': 'create2sampler4upu'}
#           # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
#           # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': ...
#           # FILTERINGMODE  :  CL_FILTER_NEAREST
#           # FUNCTION2CALLBACK  :  <function trace2sampler4upu at 0x00000000039A76C8>
#           # NACK2RETURN  :   
#           # NORMALIZATION  :  CL_TRUE
#           # PIPE  :  (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
#           # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
#           # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B3D0B8>
#   except:
#       print('(Step 2Z1/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER4UPU *** ', time4xi())
#
#   #2 
#   print('(Step 123A/700) OF UPU2SAMPLER4XI5TEST - TRYING TO CREATE SAMPLER for UPU ', time4xi()) 
#   # 
#   try:
#       xi2upu = UPU2Sampler4Xi()                            
#       response4create2sampler = xi2upu.create2sampler()                                  
#       keys2response = response4create2sampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2sampler[key2response])
#           # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-12B-14B-15B-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-32B-33B-34B-
#           # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
#           # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
#           # CODE2ERROR  :  0
#           # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
#           # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': 
#           # COUNT2REFERENCE  :  1
#           # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4upu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4upu', 'METHOD': 'create2sampler4upu'}
#           # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568'
#           # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': 
#           # FILTERINGMODE  :  CL_FILTER_NEAREST
#           # FUNCTION2CALLBACK  :  <function trace2sampler4upu at 0x00000000039676C8>
#           # NACK2RETURN  :   
#           # NORMALIZATION  :  CL_TRUE
#           # PIPE  :  (<read-write PipeConnection, handle 408>, <read-write PipeConnection, handle 424>)
#           # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
#           # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B02E48>
#           
#   except:
#       print('(Step 123Z/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER for UPU ', time4xi()) 
#          
#">
# -------------------------------------------------------------------------------------------------   
def create2sampler4upu(task4sampler2upu=None):

    '''
    creates 2D sampler for UPU
    '''
    
    global upu2sampler4xi                                                                                              # 2D iamge of UPU  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2sampler4upu" 
    method2print = "create2sampler4upu"

    message2print = "{(Step 1A/70) started" + "; create2sampler4upu-started: " + str(create2sampler4upu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2sampler4upu at 0x00000000038EF6C8>
  
             
    message2print = "{(Step 1B/70) passed" + "; task4sampler2upu-to-create2sampler4upu: " + str(task4sampler2upu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # None

    code2ack  = ' '
    code2nack = ' '    
    
    upu2sampler4xi = {}                                                                                             # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4sampler2upu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO UPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4sampler2upu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4sampler2upu-created-by-create2sampler4upu to: " + str(task4sampler2upu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            function2callback4upu = trace2sampler4upu                                                               # CALLBACK FUNCTION FOR UPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4upu-created-by-create2sampler4upu to: " + str(function2callback4upu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2sampler4upu at 0x00000000038EF5C8>
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2sampler4upu"                                                         # MODULE OF UPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2sampler4upu"                                                         # FUNCTION OF UPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2sampler4upu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR UPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2sampler4upu to: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4upu-failed ; time: 21:58:10 11/07/11 Pacific Standard Time}', 
            #  'CLASS': 'create2sampler4upu', 
            #  'METHOD': 'create2sampler4upu'}; time: 21:58:10 11/07/11 Pacific Standard Time} 

            code2ack  = code2ack + '1E-'
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - EXTRA                      
            # ---------------------------------------------------------------------------------------------              
            task4sampler2upu['DATA2CALLBACK'] = args2callback                                                       # USER DATA PASSED TO UPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4sampler2upu['FUNCTION2CALLBACK'] = function2callback4upu                                           # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4sampler2upu-created-by-create2sampler4upu to: " + str(task4sampler2upu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2sampler4upu at 0x00000000038EF5C8>, 
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4upu-failed ; time: 21:58:10 11/07/11 Pacific Standard Time}', 
            #  'CLASS': 'create2sampler4upu', 'METHOD': 'create2sampler4upu'}}; time: 21:58:10 11/07/11 Pacific Standard Time}

            
            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-created-by-create2sampler4upu to: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            try:
                platform2xi = get2platformids4xi()                                                                  # PLATFORM IS COMMON TO ALL DEVICES I.E TO DEVICE XI
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2sampler4upu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 21:58:10 11/07/11 Pacific Standard Time} 
                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2sampler4upu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4sampler2upu['PLATFORM'] = platform2xi                                                          # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - REQUIRED                         
            # ---------------------------------------------------------------------------------------------    
            context2upu = {}
            message2print = "{(Step 3A/70) trying" + "; context2upu-trying-by-create2sampler4upu: " + str(context2upu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2upu = get2context4upu()                                                                     # NO PARAMETERS - THE SYSTEM CREATES CONTEXT IF REQUIRED  
                
                message2print = "{(Step 3B/70) got" + "; context2upu-got-by-create2sampler4upu: " + str(context2upu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ... 
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2upu-failed-by-create2sampler4upu: " + str(context2upu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
                
            task4sampler2upu ['CONTEXT'] = context2upu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - EXTRA                            
            # ---------------------------------------------------------------------------------------------    
            device2upu = {}
            
            message2print = "{(Step 4A/70) trying" + "; device2upu-trying-by-create2sampler4upu: " + str(device2upu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2upu = get2upu4xi()                                                                           # THE SYSTEM CREATES DEVICE INFO, IF NECESSARY    
                
                message2print = "{(Step 4B/70) got" + "; device2upu-got-by-create2sampler4upu: " + str(device2upu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ....
                
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2upu-failed-by-create2sampler4upu: " + str(device2upu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4sampler2upu ['DEVICE'] = device2upu
            
                   
            # ---------------------------------------------------------------------------------------------
            # (5) ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4sampler2upu ['CODE2ERROR'] = 0             
            code2ack  = code2ack + '5B-'              

            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            queue2upu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2upu-trying-by-create2sampler4upu: " + str(queue2upu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2upu = Queue4Xi()                                                                                  # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2upu-got-by-create2sampler4upu: " + str(queue2upu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003B7E7F0>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2upu-failed-by-create2sampler4upu: " + str(queue2upu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4sampler2upu ['QUEUE'] = queue2upu

            
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - EXTRA                              
            # ---------------------------------------------------------------------------------------------         
            pipe2upu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2upu-trying-by-create2sampler4upu: " + str(pipe2upu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2upu = Pipe4Xi()                                                                                    # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2upu-got-by-create2sampler4upu: " + str(pipe2upu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2upu-failed-by-create2sampler4upu: " + str(pipe2upu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4sampler2upu ['PIPE'] = pipe2upu 
            
            # ---------------------------------------------------------------------------------------------
            # (8) COMMAND QUEUE INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            commandqueueinfo2upu = {}
           
            message2print = "{(Step 8A/70) trying" + "; commandqueueinfo2upu-trying-by-create2sampler4upu: " + str(commandqueueinfo2upu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                        
            try:
                commandqueueinfo2upu = get2commandqueueinfo4upu()                                                    # SYSTEM CREATES COMMAND QUEUE, IF NECESSARY   
                message2print = "{(Step 8B/70) got" + "; commandqueueinfo2upu-got-by-create2sampler4upu: " + str(commandqueueinfo2upu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # 'DATA2CALLBACK': {'MESSAGE': ... 
                
                code2ack  = code2ack + '8B-'  
            except:
                message2print = "{(Step 8Z/70) failed" + "; commandqueueinfo2upu-failed-by-create2sampler4upu: " + str(commandqueueinfo2upu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '8Z-'
        
            task4sampler2upu ['COMMANDQUEUE'] = commandqueueinfo2upu
            
            
            
            # ---------------------------------------------------------------------------------------------
            # (9) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            bufferinfo2upu = {}
           
            message2print = "{(Step 9A/70) trying" + "; bufferinfo2upu-trying-by-create2sampler4upu: " + str(bufferinfo2upu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                bufferinfo2upu = get2bufferinfo4upu()                                                                   # SYSTEM CREATES BUFFER FOR UPU, IF NECESSARY
                message2print = "{(Step 9B/70) got" + "; bufferinfo2upu-got-by-create2sampler4upu: " + str(bufferinfo2upu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
                
                code2ack  = code2ack + '9B-' 
            except:
                message2print = "{(Step 9Z/70) failed" + "; bufferinfo2upu-failed-by-create2sampler4upu: " + str(bufferinfo2upu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '9Z-'
        
            task4sampler2upu ['BUFFER'] = bufferinfo2upu 
            
            # ---------------------------------------------------------------------------------------------
            # (10) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            eventinfo2upu = {}
           
            message2print = "{(Step 10A/70) trying" + "; eventinfo2upu-trying-by-create2sampler4upu: " + str(eventinfo2upu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                eventinfo2upu = get2eventinfo4upu()                                                                     # SYSTEM CREATES EVENT IF NECESSAY   
                message2print = "{(Step 10B/70) got" + "; eventinfo2upu-got-by-create2sampler4upu: " + str(eventinfo2upu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'DATA2CALLBACK': ...
                
                code2ack  = code2ack + '10B-' 
            except:
                message2print = "{(Step 10Z/70) failed" + "; eventinfo2upu-failed-by-create2sampler4upu: " + str(eventinfo2upu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '10Z-'
        
            task4sampler2upu ['EVENT'] = eventinfo2upu             
            
            # ---------------------------------------------------------------------------------------------
            # (11) NORMALIZATION - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            normalization2upu  = 'CL_TRUE'                      # CL_TRUE or CL_FALSE
           
            message2print = "{(Step 11B/70) set" + "; normalization2upu-set-by-create2sampler4upu to: " + str(normalization2upu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # CL_TRUE 
            code2ack  = code2ack + '11B-' 
        
            task4sampler2upu ['NORMALIZATION'] = normalization2upu 
            
                        
            # ---------------------------------------------------------------------------------------------
            # (12) ADDRESSINGMODE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            addressingmode2upu  = 'CL_ADDRESS_MIRRORED_REPEAT'  # CL_ADDRESS_MIRRORED_REPEAT, CL_ADDRESS_REPEAT, CL_ADDRESS_CLAMP_TO_EDGE, CL_ADDRESS_CLAMP, CL_ADDRESS_NONE
           
            message2print = "{(Step 12B/70) set" + "; addressingmode2upu-set-by-create2sampler4upu to: " + str(addressingmode2upu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # CL_ADDRESS_MIRRORED_REPEAT 
            code2ack  = code2ack + '12B-' 
        
            task4sampler2upu ['ADDRESSINGMODE'] = addressingmode2upu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14) FILTERINGMODE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            filteringmode2upu  = 'CL_FILTER_NEAREST'  # CL_FILTER_NEAREST, or CL_FILTER_LINEAR
           
            message2print = "{(Step 14B/70) set" + "; filteringmode2upu-set-by-create2sampler4upu to: " + str(filteringmode2upu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # CL_FILTER_NEAREST
            code2ack  = code2ack + '14B-' 
        
            task4sampler2upu ['FILTERINGMODE'] = filteringmode2upu
            
            # ---------------------------------------------------------------------------------------------
            # (15) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            count2reference2upu  = 1
           
            message2print = "{(Step 15B/70) set" + "; count2reference2upu-set-by-create2sampler4upu to: " + str(count2reference2upu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '15B-' 
        
            task4sampler2upu ['COUNT2REFERENCE'] = count2reference2upu                                    
                                                                                                                      
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4sampler2upu-yielded-by-create2sampler4upu: " + str(task4sampler2upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-' 

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4sampler2upu.keys()        
    message2print = "{(Step 19A/70) using" + "; keys2task-using-by-create2sampler4upu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # ['ADDRESSINGMODE', 'BUFFER', 'CODE2ERROR', 'COMMANDQUEUE', 'CONTEXT', 'COUNT2REFERENCE', 'DATA2CALLBACK', 'DEVICE', 'EVENT', 'FILTERINGMODE', 'FUNCTION2CALLBACK', 'NORMALIZATION', 'PIPE', 'PLATFORM', 'QUEUE']; time: 21:58:10 11/07/11 Pacific Standard Time}

    
  
    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - CREATE SAMPLER FOR UPU! 
    # ---------------------------------------------------------------------------------------------    
    upu2sampler4xi = {}                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; upu2sampler4xi-initialized-by-create2sampler4upu to: " + str(upu2sampler4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {} 
    
    message2print = "{(Step 21A0/70) try" + "; data2callback-try-by-create2sampler4upu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA 
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['DATA2CALLBACK'] = task4sampler2upu['DATA2CALLBACK']
        
        message2print = "{(Step 21A1/70) initialized" + "; data2callback-created-by-create2sampler4upu to: " + str(upu2sampler4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4upu-failed ; time: 21:58:10 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4upu', 'METHOD': 'create2sampler4upu'} 
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-upu2sampler4xi-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-create2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['FUNCTION2CALLBACK'] = task4sampler2upu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) initialized" + "; function2callback-created-by-create2sampler4upu to: " + str(upu2sampler4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # <function trace2sampler4upu at 0x00000000038EF5C8> 
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-upu2sampler4xi-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform-try-by-create2sampler4upu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['PLATFORM'] = task4sampler2upu['PLATFORM']
        
        message2print = "{(Step 22C1/70) initialized" + "; platform-created-by-create2sampler4upu to: " + str(upu2sampler4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1} 
  
        code2ack  = code2ack + '22C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-upu2sampler4xi-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2upu-try-by-create2sampler4upu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['CONTEXT'] = task4sampler2upu['CONTEXT']
        
        message2print = "{(Step 23B/70) initialized" + "; context-created-by-create2sampler4upu to: " + str(upu2sampler4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ... 
        
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-upu2sampler4xi-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-create2sampler4upu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['DEVICE'] = task4sampler2upu['DEVICE']
        
        message2print = "{(Step 24B/70) initialized" + "; device-created-by-create2sampler4upu to: " + str(upu2sampler4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ... 
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-upu2sampler4xi-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-create2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['CODE2ERROR'] = task4sampler2upu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) initialized" + "; code2error-created-by-create2sampler4upu to: " + str(upu2sampler4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-upu2sampler4xi-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-create2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['QUEUE'] = task4sampler2upu['QUEUE']
        
        message2print = "{(Step 26B/70) initialized" + "; queue-created-by-create2sampler4upu to: " + str(upu2sampler4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # <queue4xi.Queue4Xi object at 0x0000000003B7E7F0> 
        
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-upu2sampler4xi-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-create2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['PIPE'] = task4sampler2upu['PIPE']
        
        message2print = "{(Step 27B/70) initialized" + "; pipe-created-by-create2sampler4upu to: " + str(upu2sampler4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>) 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-upu2sampler4xi-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-create2sampler4upu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['COMMANDQUEUE']  = task4sampler2upu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) initialized" + "; commandqueue-created-by-create2sampler4upu to: " + str(upu2sampler4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ... 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
              
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-create2sampler4upu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['BUFFER']  = task4sampler2upu['BUFFER']  
 
        message2print = "{(Step 29B/70) initialized" + "; bufferinfo-created-by-create2sampler4upu to: " + str(upu2sampler4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
        
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-create2sampler4upu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['EVENT']  = task4sampler2upu['EVENT']  
 
        message2print = "{(Step 30B/70) initialized" + "; eventinfo-created-by-create2sampler4upu to: " + str(upu2sampler4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'DATA2CALLBACK': ...
        
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'            
                

    message2print = "{(Step 31A/70) try" + "; normalization-try-by-create2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31) NORMALIZATION - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['NORMALIZATION']  = task4sampler2upu['NORMALIZATION']  
 
        message2print = "{(Step 31B/70) initialized" + "; normalization-created-by-create2sampler4upu to: " + str(upu2sampler4xi['NORMALIZATION'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # CL_TRUE; 
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; normalization-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '31Z1-'     

    message2print = "{(Step 32A/70) try" + "; addressingmode-try-by-create2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (32) ADDRESSINGMODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['ADDRESSINGMODE']  = task4sampler2upu['ADDRESSINGMODE']  
 
        message2print = "{(Step 32B/70) initialized" + "; addressingmode-created-by-create2sampler4upu to: " + str(upu2sampler4xi['ADDRESSINGMODE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # CL_ADDRESS_MIRRORED_REPEAT
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; addressingmode-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '32Z1-'     
        
    message2print = "{(Step 33A/70) try" + "; filteringmode-try-by-create2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) FILTERINGMODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['FILTERINGMODE']  = task4sampler2upu['FILTERINGMODE']  
 
        message2print = "{(Step 33B/70) initialized" + "; filteringmode-created-by-create2sampler4upu to: " + str(upu2sampler4xi['FILTERINGMODE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # CL_FILTER_NEAREST 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; filteringmode-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '33Z1-'     
        
    message2print = "{(Step 34A/70) try" + "; count2reference-try-by-create2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['COUNT2REFERENCE']  = task4sampler2upu['COUNT2REFERENCE']  
 
        message2print = "{(Step 34B/70) initialized" + "; count2reference-created-by-create2sampler4upu to: " + str(upu2sampler4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; count2reference-yielded-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '34Z1-'     
        
                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    upu2sampler4xi ['ACK2RETURN']  = code2ack
    upu2sampler4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; upu2sampler4xi-returning-by-create2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1 ...
    
    return upu2sampler4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2sampler4upu" usage = "
#    
#   print('(Step 4B/33) OF UPU2SAMPLER4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
#   platform2xi = {}
#   try:
#       platform2xi = get2platformids4xi()
#       print('(Step 4B/33) of CONTEXT4UPU5TEST - GOT PLATFORMIDS4XI', platform2xi) 
#   except:
#       print('(Step 4Z/33) of CONTEXT4UPU5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
#    
# 
#   ... other data for set ...
#    
#        
#   response4set2sampler = {} 
#   print('(Step 11F/700) OF UPU2SAMPLER4XI5TEST - TRYING TO SET SAMPLER4UPU ', time4xi())   
#   try:                               
#       response4set2sampler = set2sampler4upu(task4set2sampler)                                                                                                         
#       keys2response = response4set2sampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4set2sampler[key2response])
#           # ACK2RETURN  :   23B-24B-25B-26B-27B-28B-31B-32B-33B-
#           # ADDRESSINGMODE  :  CL_ADDRESS_REPEAT
#           # BUFFER  :  {'CODE2ERROR': 0 ...
#           # CODE2ERROR  :  0
#           # COMMANDQUEUE  :  {'CODE2ERROR': 0, ...
#           # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
#           # COUNT2REFERENCE  :  1
#           # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4upu-failed ; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4upu', 'METHOD': 'create2sampler4upu'}
#           # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
#           # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': ...
#           # FILTERINGMODE  :  CL_FILTER_NEAREST
#           # FUNCTION2CALLBACK  :  <function trace2sampler4upu at 0x00000000038CF5C8>
#           # NACK2RETURN  :   21Z1-22Z2-22Z3-29Z1-30Z1-34Z1-
#           # NORMALIZATION  :  CL_TRUE
#           # PIPE  :  (<read-write PipeConnection, handle 520>, <read-write PipeConnection, handle 524>)
#           # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
#           # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B53B00>
#           
#           
#   except:
#       print('(Step 11Z2/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO SET SAMPLER4UPU *** ', time4xi())  
#
#">
# -------------------------------------------------------------------------------------------------   
def set2sampler4upu(task4samplerset2upu=None):

    '''
    sets 2D samplers for UPU
    '''
    global upu2sampler4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2sampler4upu"
    method2print = "set2sampler4upu"

    message2print = "{(Step 1A/33) started" + "; set2sampler4upu-started: " + str(set2sampler4upu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2sampler4upu at 0x00000000038EF748>
    
    message2print = "{(Step 1B/33) passed" + "; task4samplerset2upu-to-set2sampler4upu: " + str(task4samplerset2upu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'CODE2ERROR': 0, 
    #  'QUEUE': <queue4xi.Queue4Xi object at 0x0000000003918390>, 
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK':...
          
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if upu2sampler4xi is None:
            upu2sampler4xi = create2sampler4upu()                                                                              # INITIALIZE SAMPLER FOR UPU 
            message2print = "{(Step 1C/70) set" + "; upu2sampler4xi-set-by-set2sampler4upu to: " + str(upu2sampler4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2sampler4upu-skipped-by-set2sampler4upu: " + str(create2sampler4upu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function create2sampler4upu at 0x00000000038EF6C8>                                 
    except:
        try:
            upu2sampler4xi = create2sampler4upu()
            message2print = "{(Step 1E/70) set" + "; upu2sampler4xi-set-by-set2sampler4upu to: " + str(upu2sampler4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            upu2sampler4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; upu2sampler4xi-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET            
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['DATA2CALLBACK'] = task4samplerset2upu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2sampler4upu to: " + str(upu2sampler4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-upu2sampler4xi-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['FUNCTION2CALLBACK'] = task4samplerset2upu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2sampler4upu to: " + str(upu2sampler4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-upu2sampler4xi-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['PLATFORM'] = task4samplerset2upu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2sampler4upu to: " + str(upu2sampler4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-upu2sampler4xi-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2upu-try-by-set2sampler4upu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['CONTEXT'] = task4samplerset2upu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2sampler4upu to: " + str(upu2sampler4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-upu2sampler4xi-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2sampler4upu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['DEVICE'] = task4samplerset2upu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2sampler4upu to: " + str(upu2sampler4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'RESOLUTION2TIMER4PROFILING': 318 ... 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-upu2sampler4xi-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['CODE2ERROR'] = task4samplerset2upu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2sampler4upu to: " + str(upu2sampler4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-upu2sampler4xi-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['QUEUE'] = task4samplerset2upu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2sampler4upu to: " + str(upu2sampler4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # <queue4xi.Queue4Xi object at 0x0000000003918390>
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-upu2sampler4xi-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['PIPE'] = task4samplerset2upu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2sampler4upu to: " + str(upu2sampler4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # (<read-write PipeConnection, handle 520>, <read-write PipeConnection, handle 524>) 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-upu2sampler4xi-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2sampler4upu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['COMMANDQUEUE']  = task4samplerset2upu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2sampler4upu to: " + str(upu2sampler4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2sampler4upu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['BUFFER']  = task4samplerset2upu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2sampler4upu to: " + str(upu2sampler4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2sampler4upu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['EVENT']  = task4samplerset2upu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2sampler4upu to: " + str(upu2sampler4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        
        code2nack  = code2nack + '30Z1-'            
                
    message2print = "{(Step 31A/70) try" + "; normalization-try-by-set2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31) NORMALIZATION - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['NORMALIZATION']  = task4samplerset2upu['NORMALIZATION']  
 
        message2print = "{(Step 31B/70) set" + "; normalization-set-by-set2sampler4upu to: " + str(upu2sampler4xi['NORMALIZATION'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # CL_TRUE
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; normalization-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  
        
    message2print = "{(Step 32A/70) try" + "; addressingmode-try-by-set2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (32) ADDRESSINGMODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['ADDRESSINGMODE']  = task4samplerset2upu['ADDRESSINGMODE']  
 
        message2print = "{(Step 32B/70) set" + "; addressingmode-set-by-set2sampler4upu to: " + str(upu2sampler4xi['ADDRESSINGMODE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # CL_ADDRESS_CLAMP_TO_EDGE
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; addressingmode-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 
        
    message2print = "{(Step 33A/70) try" + "; filteringmode-try-by-set2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) FILTERINGMODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['FILTERINGMODE']  = task4samplerset2upu['FILTERINGMODE']  
 
        message2print = "{(Step 33B/70) set" + "; filteringmode-set-by-set2sampler4upu to: " + str(upu2sampler4xi['FILTERINGMODE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # CL_FILTER_LINEAR
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; filteringmode-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        
        code2nack  = code2nack + '33Z1-'             
        
    message2print = "{(Step 34A/70) try" + "; count2reference-try-by-set2sampler4upu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        upu2sampler4xi['COUNT2REFERENCE']  = task4samplerset2upu['COUNT2REFERENCE']  
 
        message2print = "{(Step 34B/70) set" + "; count2reference-set-by-set2sampler4upu to: " + str(upu2sampler4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; count2reference-yielded-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        
        code2nack  = code2nack + '34Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    upu2sampler4xi ['ACK2RETURN']  = code2ack
    upu2sampler4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; upu2sampler4xi-returning-by-set2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    
    return upu2sampler4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2sampler4upu" usage = "
#
#   task4release2sampler  = {} 
#   task4release2sampler  ['COUNT2REFERENCE'] = 1 
#   response4release2sampler = {}
#   
#   print('(Step 12A/700) OF UPU2SAMPLER4XI5TEST - TRYING TO RELEASE SAMPLER OF UPU DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4release2sampler = release2sampler4upu(task4release2sampler)                                                                                             
#                        
#       keys2response = response4release2sampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4release2sampler[key2response])
#           # COUNT2REFERENCE  :  0
#       
#   except:
#       print('(Step 12Z1/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO RELEASE SAMPLER OF UPU DEVICE ', time4xi()) 
#                 
#">
# -------------------------------------------------------------------------------------------------   
def release2sampler4upu(task4release2upu=None):

    '''
    releases upu2sampler4xi
    '''
    global upu2sampler4xi  
    global code2ack
    global code2nack
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2sampler4upu"
    method2print = "release2sampler4upu" 

    message2print = "{(Step 1A/33) started" + "; release2sampler4upu-started: " + str(release2sampler4upu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function release2sampler4upu at 0x00000000038CF7C8> 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4release2upu-to-release2sampler4upu: " + str(task4release2upu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'COUNT2REFERENCE': 1}
    

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if upu2sampler4xi is None:
            upu2sampler4xi = create2sampler4upu()                                                                       # INITIALIZE SAMPLER                 
    except:
        try:
            upu2sampler4xi = create2sampler4upu()
        except:
            upu2sampler4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; upu2sampler4xi-yielded-by-release2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2sampler4upu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2upu is None:
        task4release2upu = {}
        task4release2upu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        upu2sampler4xi['COUNT2REFERENCE'] = upu2sampler4xi['COUNT2REFERENCE'] - task4release2upu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2sampler4upu: " + str(upu2sampler4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
         
        if upu2sampler4xi['COUNT2REFERENCE'] < 0:
            upu2sampler4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2sampler4upu: " + " ** " + str(upu2sampler4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 
             
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            upu2sampler4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2sampler4upu: " + " ** " + str(upu2sampler4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; upu2sampler4xi-yielded-by-release2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    upu2sampler4xi ['ACK2RETURN']  = code2ack
    upu2sampler4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; upu2sampler4xi-returning-by-release2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 'COUNT2REFERENCE': 0
    
    
    return upu2sampler4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2sampler4upu" usage = "
#
#   task4retain2sampler  = {}
#   task4retain2sampler  ['COUNT2REFERENCE'] = 1 
#   response4retain2sampler = {}
#   print('(Step 13A/700) OF UPU2SAMPLER4XI5TEST - TRYING TO RETAIN SAMPLER OF UPU DEVICE ', time4xi())   
#   try:                               
#       response4retain2sampler = retain2sampler4upu(task4retain2sampler)                                                                                                 
#                      
#       keys2response = response4retain2sampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4retain2sampler[key2response])
#           # COUNT2REFERENCE  :  1
#           
#   except:
#       print('(Step 13Z1/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO RETAIN SAMPLER OF UPU DEVICE ', time4xi())  
#
#">
# -------------------------------------------------------------------------------------------------   
def retain2sampler4upu(task4retain2upu=None):

    '''
    retains either upu2sampler4xi
    '''
    global upu2sampler4xi 
    
     
    global code2ack
    global code2nack
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2sampler4upu"
    method2print = "retain2sampler4upu"

    message2print = "{(Step 1A/33) started" + "; retain2sampler4upu-started: " + str(retain2sampler4upu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function retain2sampler4upu at 0x00000000038CF848> 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2upu-to-retain2sampler4upu: " + str(task4retain2upu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'COUNT2REFERENCE': 1}
    
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/70) - PROVIDE TASKS, IF NECESSARY AND CHECK GIVEN TASKS 
    # -----------------------------------------------------------------------------------------    
    if task4retain2upu is None:
        task4retain2upu = {}
        task4retain2upu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 2A/33) set" + "; task4retain2upu-set-by-retain2sampler4upu to: " + str(task4retain2upu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    else:
        pass

    
    # -----------------------------------------------------------------------------------------
    # (Step 3/70) - CHECK COUNT2REFERENCE
    # -----------------------------------------------------------------------------------------         
    if 'COUNT2REFERENCE' in task4retain2upu.keys():
        pass
    else:
        task4retain2upu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3A/33) set" + "; count2reference-set-by-retain2sampler4upu to: " + str(task4retain2upu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                   
    if task4retain2upu['COUNT2REFERENCE'] < 1:
        task4retain2upu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3B/33) set" + "; count2reference-set-by-retain2sampler4upu to: " + str(task4retain2upu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
        
    # -----------------------------------------------------------------------------------------
    # (Step 4/70) - INITIALIZE SAMPLER IF NECESSARY
    # -----------------------------------------------------------------------------------------
    try:
        if upu2sampler4xi is None:
            upu2sampler4xi = create2sampler4upu()
            message2print = "{(Step 4A/70) created" + "; upu2sampler4xi-created-by-retain2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                                                          
    except:
        try:
            upu2sampler4xi = create2sampler4upu()
            message2print = "{(Step 4B/70) created" + "; upu2sampler4xi-created-by-retain2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
        except:
            upu2sampler4xi = {}
            message2print = "{(Step 4Z/70) yielded" + "; upu2sampler4xi-yielded-by-retain2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z-' 


    # -----------------------------------------------------------------------------------------
    # (Step 5/70) - RETAIN
    # -----------------------------------------------------------------------------------------             
    try:
        upu2sampler4xi['COUNT2REFERENCE'] = upu2sampler4xi['COUNT2REFERENCE'] + task4retain2upu['COUNT2REFERENCE']
        message2print = "{(Step 6A/70) calculated" + "; count2reference-calculated-by-retain2sampler4upu: " + str(upu2sampler4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1              
        if upu2sampler4xi['COUNT2REFERENCE'] <= 0:
            upu2sampler4xi['COUNT2REFERENCE'] = 1
            message2print = "{(Step 6Z1/70) warning" + "; count2reference-warning-by-retain2sampler4upu: " + " ** " + str(upu2sampler4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            code2nack  = code2nack + '6Z1-'
        else:
            code2ack  = code2ack + '6C-'

    except:
        try:
            upu2sampler4xi['COUNT2REFERENCE'] = 1
        
            message2print = "{(Step 7Z1/70) warning" + "; count2reference-warning-by-retain2sampler4upu: " + " ** " + str(upu2sampler4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '7Z1-'
        
        except:
            message2print = "{(Step 7Z2/70) yielded" + "; upu2sampler4xi-yielded-by-retain2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z2-'
        
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70) - RETURN           
    # -----------------------------------------------------------------------------------------
    
    upu2sampler4xi ['ACK2RETURN']  = code2ack
    upu2sampler4xi ['NACK2RETURN'] = code2nack     
    message2print = "{(Step 70A/70) returning" + "; upu2sampler4xi-returning-by-retain2sampler4upu: " + str(upu2sampler4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 'COUNT2REFERENCE': 1
    
    
    return upu2sampler4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2samplerinfo4upu" usage = "
#
#   print('=' *33)          
#   print('(Step 3B1/700) OF UPU2SAMPLER4XI5TEST - TRYING TO GET SOME SAMPLER INFO FOR UPU ', time4xi())     
#   print('=' *33)    
#   task4getinfo2sampler = {}
#   task4getinfo2sampler ['NORMALIZATION'] = 0
#   task4getinfo2sampler ['ADDRESSINGMODE'] = 0
#   task4getinfo2sampler ['FILTERINGMODE'] = 0  
#   try:
#       response4samplerinfo2upu = get2samplerinfo4upu(task4getinfo2sampler)                                                                      
#       print('(Step 3B2/700) OF UPU2SAMPLER4XI5TEST - GOT SOME SAMPLER INFO FOR UPU ', time4xi())  
#       keys2response = response4samplerinfo2upu.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4samplerinfo2upu[key2response])
#           # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
#           # FILTERINGMODE  :  CL_FILTER_NEAREST
#           # NORMALIZATION  :  CL_TRUE 
#           
#   except:
#       print('(Step 3Z2/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO GET SOME SAMPLER INFO FOR UPU', time4xi())
#            
#">
# -------------------------------------------------------------------------------------------------   
def get2samplerinfo4upu(task4getinfo2sampler=None):

    '''
    gets upu2sampler4xi
    '''
    
    global upu2sampler4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2samplerinfo4upu"
    method2print = "get2samplerinfo4upu"

    message2print = "{(Step 0A/33) started" + "; get2samplerinfo4upu-started: " + str(get2samplerinfo4upu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <function get2samplerinfo4upu at 0x00000000038EF8C8> 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2sampler-passed-to-get2samplerinfo4upu: " + str(task4getinfo2sampler) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # {'FILTERINGMODE': 0, 'NORMALIZATION': 0, 'ADDRESSINGMODE': 0}
    
    
    sampler2upu = {}
    try: 
        if upu2sampler4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SAMPLER FOR UPU           
            # -------------------------------------------------------------------------------------           
            sampler2upu = create2sampler4upu()
            message2print = "{(Step 1B2/33) initialized" + "; sampler2upu-initialized-by-get2samplerinfo4upu to: " + str(sampler2upu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; upu2sampler4xi-using-by-get2samplerinfo4upu: " + str(upu2sampler4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1 ...
            
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF THE SAMPLER INFO OF UPU          
        # -------------------------------------------------------------------------------------     
        dimension2xi = 0
        
        if task4getinfo2sampler is None:
            task4getinfo2sampler = {}
            sampler2upu = upu2sampler4xi
            message2print = "{(Step 1C/33) using" + "; sampler2upu-got-by-get2samplerinfo4upu: " + str(sampler2upu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4samplerinfo = task4getinfo2sampler.keys()


        keys2task = task4getinfo2sampler.keys()
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2sampler4upu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # FILTERINGMODE
                 
                sampler2upu [key2task] = upu2sampler4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-sampler2upu-set-by-get2samplerinfo4upu to: " + str(sampler2upu [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # CL_FILTER_NEAREST; NORMALIZATION; ADDRESSINGMODE
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2sampler4upu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2sampler-using-by-get2sampler4upu: " + str(task4getinfo2sampler)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; upu2sampler4xi-using-by-get2sampler4upu: " + str(upu2sampler4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                           
    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            sampler2upu = create2sampler4upu()
            message2print = "{(Step 1F/33) initialized" + "; sampler2upu-initialized-by-get2samplerinfo4upu to: " + str(sampler2upu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2sampler is None:
                sampler2upu = upu2sampler4xi
                message2print = "{(Step 1G/33) got" + "; sampler2upu-got-by-get2samplerinfo4upu: " + str(sampler2upu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2sampler.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2sampler4upu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        sampler2upu [key2task] = upu2sampler4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-sampler2upu-set-by-get2samplerinfo4upu to: " + str(sampler2upu [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2sampler4upu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)                            
        except:
            sampler2upu = {}
            message2print = "{(Step 1Z3/70) yielded" + "; sampler2upu-yielded-by-get2sampler4upu: " + str(sampler2upu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; sampler2upu-returning-by-get2samplerinfo4upu: " + str(sampler2upu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
    # FILTERINGMODE  :  CL_FILTER_NEAREST
    # NORMALIZATION  :  CL_TRUE
    
    return sampler2upu
            
#</function4xi> 
 

                                               
# =================================================================================================
#<class4xi class = "UPU2Sampler4Xi" base = "object" child = "None"
#    synopsis = "offers  methods for UPU samplers" usage = "Sampler4Xi of UPU"
#>
# =================================================================================================
class UPU2Sampler4Xi(object): 
    ''' 
    UPU2Sampler4Xi offers  methods for UPU samplers
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2upu = cpu_corecount4xi()
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (

            'create2sampler',                  # ACK 5.51  p106  

            'get2samplerinfo',                 # ACK 5.51  p108
 
            'release2sampler',                 # ACK 5.51  p107                                         
            'retain2sampler',                  # ACK 5.51  p107
 
            'set2sampler',                     # ACK
            'set2samplercallback',             # ACK 
                              
            'trace2sampler4upu'                # ACK                 
            'sense',                           # ACK
            'reason',                          # ACK
            'ace')                             # ACK   
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-UPU2Sampler4Xi" usage = "
    # 
    #   print('=' *33)          
    #   print('(Step 105A/700) OF UPU2SAMPLER4XI5TEST - CREATING SAMPLER4UPU OBJECT ', time4xi())     
    #   print('=' *33)  
    # 
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                        
    #       # ---------------------------------------------------------------------------------------------        
    #       samplerobject2upu = UPU2Sampler4Xi()
    #       print('(Step 105B/700) OF UPU2SAMPLER4XI5TEST - CREATED SAMPLER4UPU OBJECT: ', samplerobject2upu)                                  
    #       # <upu2sampler4xi.UPU2Sampler4Xi object at 0x0000000003B02320>
    #       
    #   except:
    #       print('(Step 105Z/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER4UPU OBJECT')    
    # 
    #">
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4sampler2upu = None):
        '''
        _init__ method initializes UPU2Sampler4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "UPU2Sampler4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-UPU2Sampler4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 22:37:25 11/07/11 Pacific Standard Time} 

        message2print = "{(Step 1B/33) borning" + "; upu2sampler2xi-of-UPU2Sampler4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-upu2sampler2xi-of-UPU2Sampler4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'> 
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2upu-sharing-by-upu2sampler2xi-of-UPU2Sampler4Xi: " + str(UPU2Sampler4Xi.classvariable2upu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4           
                                
        message2print = "{(Step 1E/33) passed" + "; task4sampler2upu-passed-to-init-of-UPU2Sampler4Xi: " + str(task4sampler2upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                        
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4sampler2upu-passing-to-create2sampler4upu-by-init-of-UPU2Sampler4Xi: " + str(task4sampler2upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None  
        
        upu2sampler2xi = create2sampler4upu(task4sampler2upu)
        
        message2print = "{(Step 2B/33) performed" + "; create2sampler4upu-performed-by-init-of-UPU2Sampler4Xi: " + str(create2sampler4upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2sampler4upu at 0x00000000038CF6C8>
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; upu2sampler2xi-of-UPU2Sampler4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-upu2sampler2xi-of-UPU2Sampler4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2upu-shared-by-upu2sampler2xi-of-UPU2Sampler4Xi: " + str(UPU2Sampler4Xi.classvariable2upu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4          
       
        message2print = "{(Step 3D/33) returning" + "; init-of-UPU2Sampler4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 22:37:25 11/07/11 Pacific Standard Time
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2sampler-of-UPU2Sampler4Xi" usage = "
    # 
    #   print('(Step 123A/700) OF UPU2SAMPLER4XI5TEST - TRYING TO CREATE SAMPLER for UPU ', time4xi()) 
    #   # 
    #   try:
    #       xi2upu = UPU2Sampler4Xi()                            
    #       response4create2sampler = xi2upu.create2sampler()                                  
    #       keys2response = response4create2sampler.keys()
    #       for key2response in sorted(keys2response):
    #           print(key2response, ' : ', response4create2sampler[key2response])
    #           # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-12B-14B-15B-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-32B-33B-34B-
    #           # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
    #           # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
    #           # CODE2ERROR  :  0
    #           # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
    #           # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': 
    #           # COUNT2REFERENCE  :  1
    #           # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4upu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4upu', 'METHOD': 'create2sampler4upu'}
    #           # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568'
    #           # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': 
    #           # FILTERINGMODE  :  CL_FILTER_NEAREST
    #           # FUNCTION2CALLBACK  :  <function trace2sampler4upu at 0x00000000039676C8>
    #           # NACK2RETURN  :   
    #           # NORMALIZATION  :  CL_TRUE
    #           # PIPE  :  (<read-write PipeConnection, handle 408>, <read-write PipeConnection, handle 424>)
    #           # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
    #           # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B02E48>
    #           
    #   except:
    #       print('(Step 123Z/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER for UPU ', time4xi())                   
    #                     
    #">   
    # ---------------------------------------------------------------------------------------------   
    def create2sampler(self, task4sampler2create = None):
        '''
        create2sampler method creates 2D sampler objects of UPU2Sampler4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "UPU2Sampler4Xi"
        method2print = "create2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; create2sampler-of-UPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4sampler2create-passed-to-create-of-UPU2Sampler4Xi: " + str(task4sampler2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4sampler2create-passing-to-create2sampler4upu-by-create2sampler-of-UPU2Sampler4Xi: " + str(task4sampler2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        upu2sampler2xi = create2sampler4upu(task4sampler2create)

        message2print = "{(Step 2B/33) performed" + "; create2sampler4upu-performed-by-create2sampler-of-UPU2Sampler4Xi: " + str(create2sampler4upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; upu2sampler2xi-returning-by-create2sampler-of-UPU2Sampler4Xi: " + str(upu2sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return upu2sampler2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2sampler-of-UPU2Sampler4Xi" usage = "
    #   print('(Step 1A/33) OF UPU2SAMPLER4XI - TRYING TO SET UPU SAMPLER')
    #   try:
    #       cc2xi = UPU2Sampler4Xi()                            
    #       sampler2upu = cc2xi.set2sampler()                                  
    #       print('(Step 1B/33) OF UPU4XI5TEST - SET UPU SAMPLER: ', sampler2upu)                                                  
    #   except:
    #       print('(Step 1Z/33) OF UPU4XI5TEST *** FAILED TO SET UPU SAMPLER ***')  
    #">
    # ---------------------------------------------------------------------------------------------   
    def set2sampler(self, task4set2sampler = None):
        '''
        sets 2D sampler UPU objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "UPU2Sampler4Xi"
        method2print = "set2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; set2sampler-of-UPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2sampler-passed-to-set2sampler-of-UPU2Sampler4Xi: " + str(task4set2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # {'CODE2ERROR': 0, 'ADDRESSINGMODE': 'CL_ADDRESS_CLAMP_TO_EDGE' ...
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2sampler-passing-to-set2sampler4upu-by-set2sampler-of-UPU2Sampler4Xi: " + str(task4set2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # {'CODE2ERROR': 0, 'ADDRESSINGMODE': 'CL_ADDRESS_CLAMP_TO_EDGE'
        
        upu2sampler2xi = set2sampler4upu(task4set2sampler)

        message2print = "{(Step 2B/33) performed" + "; set2sampler4upu-performed-by-set2sampler-of-UPU2Sampler4Xi: " + str(set2sampler4upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function set2sampler4upu at 0x00000000038CF748>
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; upu2sampler2xi-returning-by-set2sampler-of-UPU2Sampler4Xi: " + str(upu2sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, 'DATA2CALLBACK': ...
        
                
        return upu2sampler2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2samplerinfo-of-UPU2Sampler4Xi" usage = "
    #
    #   print('(Step 106A1/700) OF UPU2SAMPLER4XI5TEST - TRYING TO GET SAMPLER INFO ', time4xi())    
    #   try:                               
    #       response4get2samplerinfo = samplerobject2upu.get2samplerinfo()                                 
    #                                
    #       keys2response = response4get2samplerinfo.keys()
    #       for key2response in sorted(keys2response):
    #           print(key2response, ' : ', response4get2samplerinfo[key2response])
    #           # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-12B-14B-15B-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-32B-33B-34B-
    #           # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
    #           # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
    #           # CODE2ERROR  :  0
    #           # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
    #           # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': 
    #           # COUNT2REFERENCE  :  1
    #           # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4upu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4upu', 'METHOD': 'create2sampler4upu'}
    #           # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568'
    #           # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4upu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 
    #           # FILTERINGMODE  :  CL_FILTER_NEAREST
    #           # FUNCTION2CALLBACK  :  <function trace2sampler4upu at 0x00000000039676C8>
    #           # NACK2RETURN  :   
    #           # NORMALIZATION  :  CL_TRUE
    #           # PIPE  :  (<read-write PipeConnection, handle 412>, <read-write PipeConnection, handle 416>)
    #           # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
    #           # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B02F98>
    #           # (Step 106A2/700) OF UPU2SAMPLER4XI5TEST - TRYING TO GET SELECTED SAMPLER INFO OF UPU DEVICE  04:32:25 11/07/11 Pacific Standard Time
    #           # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
    #           # COUNT2REFERENCE  :  1
    #           # FILTERINGMODE  :  CL_FILTER_NEAREST
    #           # NORMALIZATION  :  CL_TRUE
    #           
    #   except:
    #       print('(Step 106Z1/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO GET SAMPLER INFO ', time4xi()) 
    # 
    # ">
    # ---------------------------------------------------------------------------------------------   
    def get2samplerinfo(self, task4getinfo2sampler=None):
        '''
        get2samplerinfo method gets 2D objects of UPU2Sampler4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "UPU2Sampler4Xi"
        method2print = "get2samplerinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2samplerinfo-of-UPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        upu2sampler2xi = get2samplerinfo4upu(task4getinfo2sampler)
        
        message2print = "{(Step 2A/33) returning" + "; upu2sampler2xi-returning-by-get2samplerinfo-of-UPU2Sampler4Xi: " + str(upu2sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1 ...
        
        
        return upu2sampler2xi
                            
    #</methodize4xi>


            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2sampler-of-UPU2Sampler4Xi" usage = "
    #
    # ---------------------------------------------------------------------------------------------
    # RELEASE SAMPLER BY DECREMENTING REFERENCE COUNT WITH 1             
    # ---------------------------------------------------------------------------------------------    
    #
    #   task4release2sampler  = {} 
    #   task4release2sampler  ['COUNT2REFERENCE'] = 1 
    #   response4release2sampler = {}
    #  
    #   print('(Step 133A/700) OF UPU2SAMPLER4XI5TEST - TRYING TO RELEASE SAMPLER OF UPU DEVICE ', time4xi())    
    #   # 
    #   try:                               
    #       response4release2sampler = xi2upu.release2sampler(task4release2sampler)                                                                                             
    #                       
    #       keys2response = response4release2sampler.keys()
    #       for key2response in sorted(keys2response):
    #           print(key2response, ' : ', response4release2sampler[key2response])
    #           # COUNT2REFERENCE  :  0
    #   except:
    #       print('(Step 133Z1/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO RELEASE SAMPLER OF UPU DEVICE ', time4xi())  
    #  
    #">
    # ---------------------------------------------------------------------------------------------   
    def release2sampler(self, task4release2sampler = None):
        '''
        releases UPU2Sampler4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "UPU2Sampler4Xi"
        method2print = "release2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; release2sampler-of-UPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time
            
        message2print = "{(Step 1B/33) passed" + "; task4release2sampler-passed-to-release2sampler-of-UPU2Sampler4Xi: " + str(task4release2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # {'COUNT2REFERENCE': 1}
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2sampler-passing-to-release2sampler4upu-by-release2sampler-of-UPU2Sampler4Xi: " + str(task4release2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # {'COUNT2REFERENCE': 1}
  
        upu2sampler2xi = release2sampler4upu(task4release2sampler)

        message2print = "{(Step 2B/33) performed" + "; release2sampler4upu-performed-by-release2sampler-of-UPU2Sampler4Xi: " + str(release2sampler4upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function release2sampler4upu at 0x00000000038CF7C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; upu2sampler2xi-returning-by-release2sampler-of-UPU2Sampler4Xi: " + str(upu2sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...                          
                
        return upu2sampler2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2sampler-of-UPU2Sampler4Xi" usage = "
    #
    # ---------------------------------------------------------------------------------------------
    # RETAIN SAMPLER BY DECREASING REFERENCE WITH 1             
    # ---------------------------------------------------------------------------------------------    
    # 
    #   task4retain2sampler  = {}
    #   task4retain2sampler  ['COUNT2REFERENCE'] = 1 
    #   response4retain2sampler = {}
    #   print('(Step 134A/700) OF UPU2SAMPLER4XI5TEST - TRYING TO RETAIN SAMPLER OF UPU DEVICE ', time4xi())   
    #   try:                               
    #       response4retain2sampler = xi2upu.retain2sampler(task4retain2sampler)                                                                                                 
    #                      
    #       keys2response = response4retain2sampler.keys()
    #       for key2response in sorted(keys2response):
    #           print(key2response, ' : ', response4retain2sampler[key2response])
    #           # COUNT2REFERENCE  :  1
    #   except:
    #       print('(Step 134Z1/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO RETAIN SAMPLER OF UPU DEVICE ', time4xi())
    # 
    #">
    # ---------------------------------------------------------------------------------------------   
    def retain2sampler(self, task4retain2sampler = None):
        '''
        retains UPU2Sampler4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "UPU2Sampler4Xi"
        method2print = "retain2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; retain2sampler-of-UPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time
        
            
        message2print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain2sampler-of-UPU2Sampler4Xi: " + str(task4retain2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # {'COUNT2REFERENCE': 1} 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain2sampler4upu-by-retain-of-UPU2Sampler4Xi: " + str(task4retain2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # {'COUNT2REFERENCE': 1}
        
  
        upu2sampler2xi = retain2sampler4upu(task4retain2sampler)

        message2print = "{(Step 2B/33) performed" + "; retain2sampler4upu-performed-by-retain2sampler-of-UPU2Sampler4Xi: " + str(retain2sampler4upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function retain2sampler4upu at 0x00000000039DF948>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; upu2sampler2xi-returning-by-retain2sampler-of-UPU2Sampler4Xi: " + str(upu2sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1 ...
            
                
        return upu2sampler2xi
                                                           
    #</methodize4xi>   
    
 
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2sampler-of-UPU2Sampler4Xi" usage = "
    #   print('=' *33)          
    #   print('(Step 15A/25) OF UPU2SAMPLER4XI5TEST - TRYING TO TRACE UPU: ', time4xi())      
    #   print('=' *33)      
    #   trace2upu = None
    #   try:
    #       trace2upu = xi2upu.trace2sampler () 
    #       print('(Step 15B/25) OF UPU2SAMPLER4XI5TEST - TRACE2UPU: ', trace2upu)  
    #       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4upu-failed {}; time: 01:39:15 10/06/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4upu', 'METHOD': 'trace2sampler4upu'}
    #   except:
    #       print('(Step 15Z1/25) OF UPU2SAMPLER4XI5TEST *** FAILED TO TRACE UPU: ', trace2upu)     
    #">
    # ---------------------------------------------------------------------------------------------   
    def trace2sampler(self, task4trace2sampler = None):
        '''
        traces UPU2Sampler4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "UPU2Sampler4Xi"
        method2print = "trace2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; trace2sampler-of-UPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time
         
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2sampler-passed-to-trace-of-UPU2Sampler4Xi: " + str(task4trace2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2sampler-passing-to-trace2sampler4upu-by-trace2sampler-of-UPU2Sampler4Xi: " + str(task4trace2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None
         
  
        trace2xi = trace2sampler4upu(task4trace2sampler)

        message2print = "{(Step 2B/33) performed" + "; trace2sampler4upu-performed-by-trace2sampler-of-UPU2Sampler4Xi: " + str(trace2sampler4upu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function trace2sampler4upu at 0x00000000038CF5C8>
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2sampler-of-UPU2Sampler4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4upu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4upu', 'METHOD': 'trace2sampler4upu'}; time: 22:37:25 11/07/11 Pacific Standard Time}
 
        
                 
                
        return trace2xi
                                                           
    #</methodize4xi>       


    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2samplercallback-of-UPU2Sampler4Xi" usage = "
    #
    #   print('(Step 124A/700) OF UPU2SAMPLER4XI5TEST - TRYING TO SET SAMPLER CALLBACK WITH METHOD OF OBJECT XI2UPU: ', xi2upu) 
    #   # 
    #   try:
    #                        
    #       callback2upu = xi2upu.set2samplercallback()                                  
    #       print('(Step 124B/700) OF UPU2SAMPLER4XI5TEST - SET SAMPLER WITH CALLBACK TO: ', callback2upu)
    #       # <function trace2sampler4upu at 0x00000000039676C8> 
    #                         
    #   except:
    #       print('(Step 124Z/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO SET SAMPLER CALLBACK WITH METHOD ***', time4xi()) 
    #
    #">
    # ---------------------------------------------------------------------------------------------   
    def set2samplercallback(self, task4set2samplercallback = None): 
        '''
        set2samplercallback of UPU2Sampler4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "UPU2Sampler4Xi"
        method2print = "set2samplercallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2samplercallback-of-UPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4set2samplercallback-passed-to-set2samplercallback-of-UPU2Sampler4Xi: " + str(task4set2samplercallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2samplercallback-passing-to-set2samplercallback-by-set2samplercallback-of-UPU2Sampler4Xi: " + str(task4set2samplercallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None 
        
        
        callback2upu4sampler = {} 
        try:
            callback2upu4sampler = set2samplercallback4upu (task4set2samplercallback)

            
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2upu4sampler-failed-by-set2samplercallback-of-UPU2Sampler4Xi: " + str(callback2upu4sampler) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2upu4sampler-returning-by-set2samplercallback-of-UPU2Sampler4Xi: " + str(callback2upu4sampler) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # <function trace2sampler4upu at 0x00000000038CF5C8> 
        
                                             
        return callback2upu4sampler
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-UPU2Sampler4Xi" usage = "
    #
    #   try:
    #       print(xi2upu.sense())
    #   
    #       print('=' *33)          
    #       print('(Step 170B/700) OF UPU2SAMPLER4XI5TEST - SENSED ', time4xi()) 
    #       # {'classvariable2upu-of-UPU2Sampler4Xi': 4, 'object': <upu2sampler4xi.UPU2Sampler4Xi object at 0x0000000003B02F98>}
    #       
    #       print('=' *33)
    #   except:
    #       print('(Step 170Z/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO SENSE ', time4xi())     
    #
    # ">
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses UPU2Sampler4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'UPU2Sampler4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-UPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; UPU2Sampler4Xi-sensing-by-sense-of-UPU2Sampler4Xi: " + str(UPU2Sampler4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'upu2sampler4xi.UPU2Sampler4Xi'>
            
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-UPU2Sampler4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object': <upu2sampler4xi.UPU2Sampler4Xi object at 0x0000000003B5FBE0>}
         
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2upu-of-UPU2Sampler4Xi'] = UPU2Sampler4Xi.classvariable2upu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-UPU2Sampler4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; UPU2Sampler4Xi-sensed-by-sense-of-UPU2Sampler4Xi: " + str(UPU2Sampler4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # <class 'upu2sampler4xi.UPU2Sampler4Xi'>
        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-UPU2Sampler4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'classvariable2upu-of-UPU2Sampler4Xi': 4, 'object': <upu2sampler4xi.UPU2Sampler4Xi object at 0x0000000003B5FBE0>} 
                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-UPU2Sampler4Xi" usage = "
    # 
    #   try:
    #       print(xi2upu.reason())
    #   
    #       print('=' *33)          
    #       print('(Step 171B/700) OF UPU2SAMPLER4XI5TEST - REASONED ', time4xi())
    #       # {'object-reason-object4xi': <upu2sampler4xi.UPU2Sampler4Xi object at 0x0000000003B02F98>, 'time-reason-of-UPU2Sampler4Xi': '04:32:25 11/07/11 Pacific Standard Time'}
    #       
    #       print('=' *33)       
    #   except:
    #       print('(Step 171Z/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO REASON ', time4xi())   
    #
    #">
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons UPU2Sampler4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'UPU2Sampler4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-UPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; UPU2Sampler4Xi-reasoning-by-reason-of-UPU2Sampler4Xi: " + str(UPU2Sampler4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # <class 'upu2sampler4xi.UPU2Sampler4Xi'>
        
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-UPU2Sampler4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object-reason-object4xi': <upu2sampler4xi.UPU2Sampler4Xi object at 0x0000000003B5FBE0>}
             
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-UPU2Sampler4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-UPU2Sampler4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; UPU2Sampler4Xi-reasoned-by-reason-of-UPU2Sampler4Xi: " + str(UPU2Sampler4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # <class 'upu2sampler4xi.UPU2Sampler4Xi'>
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-UPU2Sampler4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'object-reason-object4xi': <upu2sampler4xi.UPU2Sampler4Xi object at 0x0000000003B5FBE0>, 'time-reason-of-UPU2Sampler4Xi': '22:37:25 11/07/11 Pacific Standard Time'}              
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-UPU2Sampler4Xi" usage = "
    #
    #   try:
    #       print(xi2upu.ace())
    #   
    #       print('=' *33)          
    #       print('(Step 172B/700) OF UPU2SAMPLER4XI5TEST - ACED ', time4xi())                                                 
    #       # {'cores-of-UPU2Sampler4Xi': 4, 'object8xi': <upu2sampler4xi.UPU2Sampler4Xi object at 0x0000000003B02F98>} 
    #       
    #       print('=' *33) 
    #   except:
    #       print('(Step 172Z/700) OF UPU2SAMPLER4XI5TEST *** FAILED TO ACE ', time4xi())                                       
    #    
    #">
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces UPU2Sampler4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'UPU2Sampler4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-UPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; UPU2Sampler4Xi-acing-by-ace-of-UPU2Sampler4Xi: " + str(UPU2Sampler4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'upu2sampler4xi.UPU2Sampler4Xi'>           
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-UPU2Sampler4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object8xi': <upu2sampler4xi.UPU2Sampler4Xi object at 0x0000000003B5FBE0>}


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-UPU2Sampler4Xi'] = UPU2Sampler4Xi.classvariable2upu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-UPU2Sampler4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; UPU2Sampler4Xi-aced-by-ace-of-UPU2Sampler4Xi: " + str(UPU2Sampler4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'upu2sampler4xi.UPU2Sampler4Xi'> 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-UPU2Sampler4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'cores-of-UPU2Sampler4Xi': 4, 'object8xi': <upu2sampler4xi.UPU2Sampler4Xi object at 0x0000000003B5FBE0>}
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   upu2sampler4xi5test.txt
#   sense-upu2sampler4xi5test.xml
#   reason-upu2sampler4xi5test.xml
#   ace-upu2sampler4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of upu2sampler4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
